#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "arbomb_utils.h"


int _AB_test_ucsize;
int _AB_test_ratio;
int _AB_test_fcount;


/*------------------------------------------------------------------------
Procedure:     AB_u32int ID:1
Purpose:       Converts 4 bytes into an unsigned int
Byte order is 1-2-3-4
Input:
Output:
Errors:
------------------------------------------------------------------------*/
unsigned int AB_u32int( unsigned char *u32 )
{
	unsigned int value = 0;

	value = *u32;
	value += *(u32+1) << 8;
	value += *(u32+2) << 16;
	value += *(u32+3) << 24;

	//	fprintf(stdout,"u32int value = %d\n",value);

	return value;
}

/*------------------------------------------------------------------------
Procedure:     AB_u16int ID:1
Purpose:       Convert 2 bytes into an unsigned int
Byte order is 1-2
Input:
Output:
Errors:
------------------------------------------------------------------------*/
unsigned int AB_u16int( unsigned char *u16 )
{
	unsigned int value = 0;

	value = *u16;
	value += *(u16+1) << 8;

	//	fprintf(stdout,"u16int value = %d\n",value);

	return value;
}



/*------------------------------------------------------------------------
Procedure:     AB_limitstest ID:1
Purpose:       Performs tests based on the results obtained from
the archive modules.
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int AB_limits_test( struct arbomb_limits *abl, struct arbomb_limits *lcs )
{
	int result = 0;

	if ((_AB_test_ratio)&&(abl->single_ratio > 0))
	{
		if (lcs->single_ratio >= abl->single_ratio)
		{
			result = AB_ERR_RATIO;
		}
	}

	if ((_AB_test_ucsize)&&(abl->single_ucsize > 0))
	{
		if (lcs->single_ucsize >= abl->single_ucsize)
		{
			result = AB_ERR_UCSIZE;
		}
	}

	if ((_AB_test_fcount)&&(abl->archive_filecount >0))
	{
		if (lcs->archive_filecount >= abl->archive_filecount)
		{
			result = AB_ERR_FCOUNT;
		}
	}

	return result;
}


//--END.

